# Advent of Code 2019 
Solutions to [Advent of Code 2019](https://adventofcode.com/2019) in Python 3.

## Usage
To solve all puzzles with implemented solutions run 
```console
$ python3 main.py 
```
For faster execution use `pypy3`
```console
$ pypy3 main.py
```
or make the main program executable.
```console
$ chmod +x main.py
$ ./main.py
```
To download your puzzle inputs (the inputs are different for each user),
run `./main.py --fetch-session` and input your session key.
The session key can be found by inspecting the headers of a HTTP request
made from a browser on which the user is logged in. The HTTP request header
in question has the following format : `Cookie : session=key`.

For other options see `./main.py -h`.
```console
$ ./main.py -h
usage: main.py [-h] [-d DAY[-DAY]] [-i INPUT] [-t]

Solves Advent of Code 2019 puzzles. The puzzles are available at
https://adventofcode.com/2019/

optional arguments:
  -h, --help            show this help message and exit
  -d DAY[-DAY], --day DAY[-DAY]
                        solve puzzle of day DAY or of range DAY-DAY
  -i INPUT, --input INPUT
                        use INPUT as puzzle input
  -t, --test            run tests
```
